test/bin-test/test-dav-sync-hash-conflictres.sh

changeset 650
14e7101d7604
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/test/bin-test/test-dav-sync-hash-conflictres.sh	Sun Oct 06 13:27:24 2019 +0200
@@ -0,0 +1,422 @@
+#!/bin/sh
+#
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
+#
+# Copyright 2019 Olaf Wintermann. All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+#   1. Redistributions of source code must retain the above copyright
+#      notice, this list of conditions and the following disclaimer.
+#
+#   2. Redistributions in binary form must reproduce the above copyright
+#      notice, this list of conditions and the following disclaimer in the
+#      documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+
+if [ -z "$DAV_BIN" ];
+then
+	echo "DAV_BIN variable not set"
+	exit 1
+fi
+if [ -z "$DAV_SYNC_BIN" ];
+then
+	echo "DAV_BIN variable not set"
+	exit 1
+fi
+
+# checks if tmp-sync/out.txt contains a specific text
+# arg1: pattern
+# arg2: errormsg
+check_tmpout()
+{
+	TEST=`cat tmp-sync/out.txt | grep "$1"`
+	if [ $? -ne 0 ];
+	then
+		echo "$2"
+		exit 2	
+	fi
+}
+
+# do dav-sync push and check return value
+# arg1: dir
+# arg2: errormsg
+dav_sync_push()
+{
+	$DAV_SYNC_BIN push $1 > tmp-sync/out.txt
+	if [ $? -ne 0 ];
+	then
+		echo "$2"
+		exit 2
+	fi
+}
+# do dav-sync pull and check return value
+# arg1: dir
+# arg2: errormsg
+dav_sync_pull()
+{
+	$DAV_SYNC_BIN pull $1 > tmp-sync/out.txt
+	if [ $? -ne 0 ];
+	then
+		echo "$2"
+		exit 2
+	fi
+}
+
+rm -f .dav/dav-sync-tests-test2a-db.xml
+rm -f .dav/dav-sync-tests-test2b-db.xml
+
+$DAV_BIN rm dav-test-repo/sync/test2 2> /dev/null
+
+$DAV_BIN mkcol dav-test-repo/sync/test2 2> /dev/null
+
+# tmp sync dir
+rm -Rf tmp-sync
+mkdir tmp-sync
+mkdir tmp-sync/test2a
+# don't create test2b
+
+# ----------------------------------------------------------------------------
+# test 1: first pull with exiting files
+# expected result: no conflicts
+
+mkdir tmp-sync/test2a/dir1
+mkdir tmp-sync/test2a/dir1/subdir1
+
+cp synctest/file1 tmp-sync/test2a/
+cp synctest/file2 tmp-sync/test2a/dir1/
+cp synctest/file3 tmp-sync/test2a/dir1/subdir1
+cp synctest/file4 tmp-sync/test2a/dir1/subdir1
+
+cp -R tmp-sync/test2a tmp-sync/test2b
+
+dav_sync_push test2a "test 1: push failed"
+check_tmpout "4 files pushed" "test 1: wrong push counter"
+check_tmpout "0 conflicts" "test 1: wrong conflict counter (push)"
+check_tmpout "0 errors" "test 1: wrong error counter (push)"
+
+dav_sync_pull test2b "test 1: pull failed"
+check_tmpout "0 files pulled" "test 1: wrong pull counter"
+check_tmpout "0 conflicts" "test 1: wrong conflict counter (pull)"
+check_tmpout "0 errors" "test 1: wrong error counter (pull)"
+
+
+# ----------------------------------------------------------------------------
+# test 2: first push with existing resources on the server
+# expected result: no conflicts
+
+rm -f .dav/dav-sync-tests-test2a-db.xml
+
+sleep 2
+
+dav_sync_push test2a "test 2: push failed"
+check_tmpout "0 files pushed" "test 2: wrong push counter"
+check_tmpout "0 conflicts" "test 2: wrong conflict counter (push)"
+check_tmpout "0 errors" "test 2: wrong error counter (push)"
+
+dav_sync_pull test2b "test 2: pull failed"
+check_tmpout "0 files pulled" "test 2: wrong pull counter"
+check_tmpout "0 conflicts" "test 2: wrong conflict counter (pull)"
+check_tmpout "0 errors" "test 2: wrong error counter (pull)"
+
+
+# ----------------------------------------------------------------------------
+# test 3: modify file1 on both sides (with same content)
+# expected result: (pull): no conflicts
+
+sleep 2
+
+echo "test3-mod" >> tmp-sync/test2a/file1
+echo "test3-mod" >> tmp-sync/test2b/file1
+
+dav_sync_push test2a "test 3: push failed"
+check_tmpout "1 file pushed" "test 3: wrong push counter"
+check_tmpout "0 conflicts" "test 3: wrong conflict counter (push)"
+check_tmpout "0 errors" "test 3: wrong error counter (push)"
+
+dav_sync_pull test2b "test 3: pull failed"
+check_tmpout "0 files pulled" "test 3: wrong pull counter"
+check_tmpout "0 conflicts" "test 3: wrong conflict counter (pull)"
+check_tmpout "0 errors" "test 3: wrong error counter (pull)"
+
+
+# ----------------------------------------------------------------------------
+# test 4: modify file2 on both sides (with same content) and push test2b
+# expected result: (push): no conflicts
+
+sleep 2
+
+echo "test4-mod" >> tmp-sync/test2a/dir1/file2
+echo "test4-mod" >> tmp-sync/test2b/dir1/file2
+
+dav_sync_push test2a "test 4: push test2a failed"
+check_tmpout "1 file pushed" "test 4: wrong push counter (test2a)"
+check_tmpout "0 conflicts" "test 4: wrong conflict counter (test2a)"
+check_tmpout "0 errors" "test 4: wrong error counter (test2a)"
+
+dav_sync_push test2b "test 4: push test2b failed"
+check_tmpout "0 files pushed" "test 4: wrong push counter (test2b)"
+check_tmpout "0 conflicts" "test 4: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 4: wrong error counter (test2b)"
+
+dav_sync_pull test2b "test 4: pull failed"
+check_tmpout "0 files pulled" "test 4: wrong pull counter"
+check_tmpout "0 conflicts" "test 4: wrong conflict counter (pull)"
+check_tmpout "0 errors" "test 4: wrong error counter (pull)"
+
+
+# ----------------------------------------------------------------------------
+# test 5: add same new file on both sides
+# expected result: (pull): no conflicts
+
+echo "test5-newfilex1" >> tmp-sync/test2a/filex1
+echo "test5-newfilex1" >> tmp-sync/test2b/filex1
+
+echo "test5-newfilex2" >> tmp-sync/test2a/filex2
+echo "test5-newfilex2" >> tmp-sync/test2b/filex2
+
+dav_sync_push test2a "test 5: push failed"
+check_tmpout "2 files pushed" "test 5: wrong push counter (push)"
+check_tmpout "0 conflicts" "test 5: wrong conflict counter (push)"
+check_tmpout "0 errors" "test 5: wrong error counter (push)"
+
+dav_sync_pull test2b "test 5: pull failed"
+check_tmpout "0 files pulled" "test 5: wrong pull counter"
+check_tmpout "0 conflicts" "test 5: wrong conflict counter (pull)"
+check_tmpout "0 errors" "test 5: wrong error counter (pull)"
+
+
+# ----------------------------------------------------------------------------
+# test 6: add same new file on both sides and try to push both
+# expected result: no conflicts
+
+echo "test5-newfilez1" >> tmp-sync/test2a/filez1
+echo "test5-newfilez1" >> tmp-sync/test2b/filez1
+
+echo "test5-newfilez2" >> tmp-sync/test2a/filez2
+echo "test5-newfilez2" >> tmp-sync/test2b/filez2
+
+dav_sync_push test2a "test 6: push test2a failed"
+check_tmpout "2 files pushed" "test 6: wrong push counter (test2a)"
+check_tmpout "0 conflicts" "test 6: wrong conflict counter (test2a)"
+check_tmpout "0 errors" "test 6: wrong error counter (test2a)"
+
+dav_sync_push test2b "test 6: push test2b failed"
+check_tmpout "0 files pushed" "test 6: wrong push counter (test2b)"
+check_tmpout "0 conflicts" "test 6: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 6: wrong error counter (test2b)"
+
+
+# ----------------------------------------------------------------------------
+# test 7: provoke real conflict, push test2a, pull test2b
+# expected result: (pull): conflict
+
+sleep 2
+
+echo "test7-mod-a" >> tmp-sync/test2a/file1
+echo "test7-mod-b" >> tmp-sync/test2b/file1
+
+dav_sync_push test2a "test 7: push failed"
+check_tmpout "1 file pushed" "test 7: wrong push counter (push)"
+check_tmpout "0 conflicts" "test 7: wrong conflict counter (push)"
+check_tmpout "0 errors" "test 7: wrong error counter (push)"
+
+dav_sync_pull test2b "test 7: pull failed"
+check_tmpout "1 file pulled" "test 7: wrong pull counter"
+check_tmpout "1 conflict" "test 7: wrong conflict counter (pull)"
+check_tmpout "0 errors" "test 7: wrong error counter (pull)"
+
+$DAV_SYNC_BIN delete-conflicts test2b > /dev/null 2>&1
+if [ $? -ne 0 ]; then
+	echo "test 7: delete-conflicts failed"
+	exit 2
+fi
+
+dav_sync_push test2b "test 7: push test2b failed"
+check_tmpout "0 files pushed" "test 7: wrong push counter (test2b)"
+check_tmpout "0 conflicts" "test 7: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 7: wrong error counter (test2b)"
+
+
+# ----------------------------------------------------------------------------
+# test 8: provoke real conflict, push both
+# expected result: (push): conflict
+
+sleep 2
+
+echo "test8-mod-a" >> tmp-sync/test2a/dir1/file2
+echo "test8-mod-b" >> tmp-sync/test2b/dir1/file2
+
+dav_sync_push test2a "test 8: push test2a failed"
+check_tmpout "1 file pushed" "test 8: wrong push counter (test2a)"
+check_tmpout "0 conflicts" "test 8: wrong conflict counter (test2a)"
+check_tmpout "0 errors" "test 8: wrong error counter (test2a)"
+
+dav_sync_push test2b "test 8: push test2b failed"
+check_tmpout "0 files pushed" "test 8: wrong push counter (test2b)"
+check_tmpout "1 conflict" "test 8: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 8: wrong error counter (test2b)"
+
+
+# ----------------------------------------------------------------------------
+# test 9: resolve push conflict by manually syncing file2
+# expected result: (push): no conflict
+
+cp -f tmp-sync/test2a/dir1/file2 tmp-sync/test2b/dir1/file2
+
+dav_sync_push test2b "test 9: push test2b failed"
+check_tmpout "0 files pushed" "test 9: wrong push counter (test2b)"
+check_tmpout "0 conflicts" "test 9: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 9: wrong error counter (test2b)"
+
+
+# ----------------------------------------------------------------------------
+# test 10: provoke real conflict, push test2a, pull test2b
+# expected result: (pull): conflict
+
+sleep 2
+
+echo "test10-mod-a" >> tmp-sync/test2a/dir1/file2
+echo "test10-mod-b" >> tmp-sync/test2b/dir1/file2
+
+dav_sync_push test2a "test 10: push test2a failed"
+check_tmpout "1 file pushed" "test 10: wrong push counter (test2a)"
+check_tmpout "0 conflicts" "test 10: wrong conflict counter (test2a)"
+check_tmpout "0 errors" "test 10: wrong error counter (test2a)"
+
+dav_sync_pull test2b "test 10: pull failed"
+check_tmpout "1 file pulled" "test 10: wrong pull counter (pull)"
+check_tmpout "1 conflict" "test 10: wrong conflict counter (pull)"
+check_tmpout "0 errors" "test 10: wrong error counter (pull)"
+
+$DAV_SYNC_BIN delete-conflicts test2b > /dev/null 2>&1
+if [ $? -ne 0 ]; then
+	echo "test 10: delete-conflicts failed"
+	exit 2
+fi
+
+dav_sync_push test2b "test 10: push test2b failed"
+check_tmpout "0 files pushed" "test 10: wrong push counter (test2b)"
+check_tmpout "0 conflicts" "test 10: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 10: wrong error counter (test2b)"
+
+
+# ----------------------------------------------------------------------------
+# test 11: If hashes are equal and 0 files are pulled, check if
+#          the db was updated. Modify a file after pull and push the new file
+# expected result: (push): no conflict, 1 file pushed
+
+sleep 2
+
+echo "test11-mod" >> tmp-sync/test2a/file1
+echo "test11-mod" >> tmp-sync/test2b/file1
+
+dav_sync_push test2a "test 11: push test2a failed"
+check_tmpout "1 file pushed" "test 11: wrong push counter (test2a)"
+check_tmpout "0 conflicts" "test 11: wrong conflict counter (test2a)"
+check_tmpout "0 errors" "test 11: wrong error counter (test2a)"
+
+dav_sync_pull test2b "test 11: pull failed"
+check_tmpout "0 files pulled" "test 11: wrong pull counter"
+check_tmpout "0 conflicts" "test 11: wrong conflict counter (pull)"
+check_tmpout "0 errors" "test 11: wrong error counter (pull)"
+
+sleep 2
+echo "test11-mod2-b" >> tmp-sync/test2b/file1
+
+dav_sync_push test2b "test 11: push test2b failed"
+check_tmpout "1 file pushed" "test 11: wrong push counter (test2b)"
+check_tmpout "0 conflicts" "test 11: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 11: wrong error counter (test2b)"
+
+
+# ----------------------------------------------------------------------------
+# test 12: same as test 11 but with a new file and not an existing file
+# expected result: (push): no conflict, 1 file pushed
+
+echo "test12-new" >> tmp-sync/test2a/new-t12
+echo "test12-new" >> tmp-sync/test2b/new-t12
+
+dav_sync_push test2a "test 12: push test2a failed"
+check_tmpout "1 file pushed" "test 12: wrong push counter (test2a)"
+check_tmpout "0 conflicts" "test 12: wrong conflict counter (test2a)"
+check_tmpout "0 errors" "test 12: wrong error counter (test2a)"
+
+dav_sync_pull test2b "test 12: pull failed"
+check_tmpout "0 files pulled" "test 12: wrong pull counter"
+check_tmpout "0 conflicts" "test 12: wrong conflict counter (pull)"
+check_tmpout "0 errors" "test 12: wrong error counter (pull)"
+
+sleep 2
+echo "test12-mod2-b" >> tmp-sync/test2b/new-t12
+
+dav_sync_push test2b "test 12: push test2b failed"
+check_tmpout "1 file pushed" "test 12: wrong push counter (test2b)"
+check_tmpout "0 conflicts" "test 12: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 12: wrong error counter (test2b)"
+
+# ----------------------------------------------------------------------------
+# test 13: Check if push updates the db, if a modified file is already
+#          updated (hashes equal). Modify file the same way on both sides,
+#          push both, modify file in test2b and push again
+# expected result: (push): no conflict, 1 file pushed
+
+echo "test13-mod" >> tmp-sync/test2a/dir1/file2
+echo "test13-mod" >> tmp-sync/test2b/dir1/file2
+
+dav_sync_push test2a "test 13: push test2a failed"
+check_tmpout "1 file pushed" "test 13: wrong push counter (test2a)"
+check_tmpout "0 conflicts" "test 13: wrong conflict counter (test2a)"
+check_tmpout "0 errors" "test 13: wrong error counter (test2a)"
+
+dav_sync_push test2b "test 13: push test2b failed"
+check_tmpout "0 files pushed" "test 13: wrong push counter (test2b)"
+check_tmpout "0 conflicts" "test 13: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 13: wrong error counter (test2b)"
+
+sleep 2
+echo "test13-mod2-b" >> tmp-sync/test2b/dir1/file2
+
+dav_sync_push test2b "test 13: push test2b (2) failed"
+check_tmpout "1 file pushed" "test 13: wrong push counter (test2b 2)"
+check_tmpout "0 conflicts" "test 13: wrong conflict counter (test2b 2)"
+check_tmpout "0 errors" "test 13: wrong error counter (test2b 2)"
+
+
+# ----------------------------------------------------------------------------
+# test 14: same as test 13 but with a new file and not an existing file
+# expected result: (push): no conflict, 1 file pushed
+
+echo "test14-mod" >> tmp-sync/test2a/dir1/new-t14
+echo "test14-mod" >> tmp-sync/test2b/dir1/new-t14
+
+dav_sync_push test2a "test 14: push test2a failed"
+check_tmpout "1 file pushed" "test 14: wrong push counter (test2a)"
+check_tmpout "0 conflicts" "test 14: wrong conflict counter (test2a)"
+check_tmpout "0 errors" "test 14: wrong error counter (test2a)"
+
+dav_sync_push test2b "test 14: push test2b failed"
+check_tmpout "0 files pushed" "test 14: wrong push counter (test2b)"
+check_tmpout "0 conflicts" "test 14: wrong conflict counter (test2b)"
+check_tmpout "0 errors" "test 14: wrong error counter (test2b)"
+
+sleep 2
+echo "test13-mod2-b" >> tmp-sync/test2b/dir1/new-t14
+
+dav_sync_push test2b "test 14: push test2b (2) failed"
+check_tmpout "1 file pushed" "test 14: wrong push counter (test2b 2)"
+check_tmpout "0 conflicts" "test 14: wrong conflict counter (test2b 2)"
+check_tmpout "0 errors" "test 14: wrong error counter (test2b 2)"

mercurial